---@class ArcCamHelperExtension
local M = {}

-- constants
local updateInterval = 0.1

-- state
local updateTime = 0
local cameraInside = false

local function requestCameraState()
	local callbackScript = "\"extensions.arcanox_camhelper.updateCameraInside(\" .. tostring(extensions.core_camera.isCameraInside()) .. \")\""
	local geScript = ("queueObjectLua(%d, %s)"):format(obj:getID(), callbackScript)

	obj:queueGameEngineLua(geScript)
end

local function updateGFX(dt)
	updateTime = updateTime + dt

	if updateTime >= updateInterval then
		requestCameraState()

		updateTime = 0
	end
end

local function updateCameraInside(inside)
	cameraInside = inside
end

local function isCameraInside()
	return cameraInside
end

M.updateGFX = updateGFX
M.updateCameraInside = updateCameraInside
M.isCameraInside = isCameraInside

return M